"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SamtoolsStats(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "SAMTOOLS_1ST_FRAGMENTS",
        "SAMTOOLS_AVERAGE_LENGTH",
        "SAMTOOLS_AVERAGE_QUALITY",
        "SAMTOOLS_BASES_DUPLICATED",
        "SAMTOOLS_BASES_MAPPED",
        "SAMTOOLS_BASES_MAPPED_CIGAR",
        "SAMTOOLS_BASES_TRIMMED",
        "SAMTOOLS_ERROR_RATE",
        "SAMTOOLS_FILTERED_SEQUENCES",
        "SAMTOOLS_INSERT_SIZE_AVERAGE",
        "SAMTOOLS_INSERT_SIZE_STANDARD_DEVIATION",
        "SAMTOOLS_INWARD_ORIENTED_PAIRS",
        "SAMTOOLS_IS_SORTED",
        "SAMTOOLS_LAST_FRAGMENTS",
        "SAMTOOLS_MAXIMUM_LENGTH",
        "SAMTOOLS_MISMATCHES",
        "SAMTOOLS_NON_PRIMARY_ALIGNMENTS",
        "SAMTOOLS_OUTWARD_ORIENTED_PAIRS",
        "SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES",
        "SAMTOOLS_PAIRS_WITH_OTHER_ORIENTATION",
        "SAMTOOLS_RAW_TOTAL_SEQUENCES",
        "SAMTOOLS_READS_DUPLICATED",
        "SAMTOOLS_READS_MAPPED",
        "SAMTOOLS_READS_MAPPED_AND_PAIRED",
        "SAMTOOLS_READS_MQ0",
        "SAMTOOLS_READS_PAIRED",
        "SAMTOOLS_READS_PROPERLY_PAIRED",
        "SAMTOOLS_READS_QC_FAILED",
        "SAMTOOLS_READS_UNMAPPED",
        "SAMTOOLS_SEQUENCES",
        "SAMTOOLS_TOTAL_LENGTH",
        "samtoolsScope",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import metrics as metrics_1_3_0

        return {
            "samtoolsScope": metrics_1_3_0.SamtoolsScope,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import metrics as metrics_1_3_0

        return {
            "org.gel.models.report.avro.SamtoolsScope": metrics_1_3_0.SamtoolsScope,
            "org.gel.models.report.avro.SamtoolsStats": metrics_1_3_0.SamtoolsStats,
        }

    __slots__ = [
        "SAMTOOLS_1ST_FRAGMENTS",
        "SAMTOOLS_AVERAGE_LENGTH",
        "SAMTOOLS_AVERAGE_QUALITY",
        "SAMTOOLS_BASES_DUPLICATED",
        "SAMTOOLS_BASES_MAPPED",
        "SAMTOOLS_BASES_MAPPED_CIGAR",
        "SAMTOOLS_BASES_TRIMMED",
        "SAMTOOLS_ERROR_RATE",
        "SAMTOOLS_FILTERED_SEQUENCES",
        "SAMTOOLS_INSERT_SIZE_AVERAGE",
        "SAMTOOLS_INSERT_SIZE_STANDARD_DEVIATION",
        "SAMTOOLS_INWARD_ORIENTED_PAIRS",
        "SAMTOOLS_IS_SORTED",
        "SAMTOOLS_LAST_FRAGMENTS",
        "SAMTOOLS_MAXIMUM_LENGTH",
        "SAMTOOLS_MISMATCHES",
        "SAMTOOLS_NON_PRIMARY_ALIGNMENTS",
        "SAMTOOLS_OUTWARD_ORIENTED_PAIRS",
        "SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES",
        "SAMTOOLS_PAIRS_WITH_OTHER_ORIENTATION",
        "SAMTOOLS_RAW_TOTAL_SEQUENCES",
        "SAMTOOLS_READS_DUPLICATED",
        "SAMTOOLS_READS_MAPPED",
        "SAMTOOLS_READS_MAPPED_AND_PAIRED",
        "SAMTOOLS_READS_MQ0",
        "SAMTOOLS_READS_PAIRED",
        "SAMTOOLS_READS_PROPERLY_PAIRED",
        "SAMTOOLS_READS_QC_FAILED",
        "SAMTOOLS_READS_UNMAPPED",
        "SAMTOOLS_SEQUENCES",
        "SAMTOOLS_TOTAL_LENGTH",
        "samtoolsScope",
    ]

    def __init__(
        self,
        SAMTOOLS_1ST_FRAGMENTS,
        SAMTOOLS_AVERAGE_LENGTH,
        SAMTOOLS_AVERAGE_QUALITY,
        SAMTOOLS_BASES_DUPLICATED,
        SAMTOOLS_BASES_MAPPED,
        SAMTOOLS_BASES_MAPPED_CIGAR,
        SAMTOOLS_BASES_TRIMMED,
        SAMTOOLS_ERROR_RATE,
        SAMTOOLS_FILTERED_SEQUENCES,
        SAMTOOLS_INSERT_SIZE_AVERAGE,
        SAMTOOLS_INSERT_SIZE_STANDARD_DEVIATION,
        SAMTOOLS_INWARD_ORIENTED_PAIRS,
        SAMTOOLS_IS_SORTED,
        SAMTOOLS_LAST_FRAGMENTS,
        SAMTOOLS_MAXIMUM_LENGTH,
        SAMTOOLS_MISMATCHES,
        SAMTOOLS_NON_PRIMARY_ALIGNMENTS,
        SAMTOOLS_OUTWARD_ORIENTED_PAIRS,
        SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES,
        SAMTOOLS_PAIRS_WITH_OTHER_ORIENTATION,
        SAMTOOLS_RAW_TOTAL_SEQUENCES,
        SAMTOOLS_READS_DUPLICATED,
        SAMTOOLS_READS_MAPPED,
        SAMTOOLS_READS_MAPPED_AND_PAIRED,
        SAMTOOLS_READS_MQ0,
        SAMTOOLS_READS_PAIRED,
        SAMTOOLS_READS_PROPERLY_PAIRED,
        SAMTOOLS_READS_QC_FAILED,
        SAMTOOLS_READS_UNMAPPED,
        SAMTOOLS_SEQUENCES,
        SAMTOOLS_TOTAL_LENGTH,
        samtoolsScope,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_3_0.SamtoolsStats model.

        :param SAMTOOLS_1ST_FRAGMENTS:
        :type SAMTOOLS_1ST_FRAGMENTS: double
        :param SAMTOOLS_AVERAGE_LENGTH:
        :type SAMTOOLS_AVERAGE_LENGTH: double
        :param SAMTOOLS_AVERAGE_QUALITY:
        :type SAMTOOLS_AVERAGE_QUALITY: double
        :param SAMTOOLS_BASES_DUPLICATED:
        :type SAMTOOLS_BASES_DUPLICATED: double
        :param SAMTOOLS_BASES_MAPPED:
        :type SAMTOOLS_BASES_MAPPED: double
        :param SAMTOOLS_BASES_MAPPED_CIGAR:
        :type SAMTOOLS_BASES_MAPPED_CIGAR: double
        :param SAMTOOLS_BASES_TRIMMED:
        :type SAMTOOLS_BASES_TRIMMED: double
        :param SAMTOOLS_ERROR_RATE:
        :type SAMTOOLS_ERROR_RATE: double
        :param SAMTOOLS_FILTERED_SEQUENCES:
        :type SAMTOOLS_FILTERED_SEQUENCES: double
        :param SAMTOOLS_INSERT_SIZE_AVERAGE:
        :type SAMTOOLS_INSERT_SIZE_AVERAGE: double
        :param SAMTOOLS_INSERT_SIZE_STANDARD_DEVIATION:
        :type SAMTOOLS_INSERT_SIZE_STANDARD_DEVIATION: double
        :param SAMTOOLS_INWARD_ORIENTED_PAIRS:
        :type SAMTOOLS_INWARD_ORIENTED_PAIRS: double
        :param SAMTOOLS_IS_SORTED:
        :type SAMTOOLS_IS_SORTED: double
        :param SAMTOOLS_LAST_FRAGMENTS:
        :type SAMTOOLS_LAST_FRAGMENTS: double
        :param SAMTOOLS_MAXIMUM_LENGTH:
        :type SAMTOOLS_MAXIMUM_LENGTH: double
        :param SAMTOOLS_MISMATCHES:
        :type SAMTOOLS_MISMATCHES: double
        :param SAMTOOLS_NON_PRIMARY_ALIGNMENTS:
        :type SAMTOOLS_NON_PRIMARY_ALIGNMENTS: double
        :param SAMTOOLS_OUTWARD_ORIENTED_PAIRS:
        :type SAMTOOLS_OUTWARD_ORIENTED_PAIRS: double
        :param SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES:
        :type SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES: double
        :param SAMTOOLS_PAIRS_WITH_OTHER_ORIENTATION:
        :type SAMTOOLS_PAIRS_WITH_OTHER_ORIENTATION: double
        :param SAMTOOLS_RAW_TOTAL_SEQUENCES:
        :type SAMTOOLS_RAW_TOTAL_SEQUENCES: double
        :param SAMTOOLS_READS_DUPLICATED:
        :type SAMTOOLS_READS_DUPLICATED: double
        :param SAMTOOLS_READS_MAPPED:
        :type SAMTOOLS_READS_MAPPED: double
        :param SAMTOOLS_READS_MAPPED_AND_PAIRED:
        :type SAMTOOLS_READS_MAPPED_AND_PAIRED: double
        :param SAMTOOLS_READS_MQ0:
        :type SAMTOOLS_READS_MQ0: double
        :param SAMTOOLS_READS_PAIRED:
        :type SAMTOOLS_READS_PAIRED: double
        :param SAMTOOLS_READS_PROPERLY_PAIRED:
        :type SAMTOOLS_READS_PROPERLY_PAIRED: double
        :param SAMTOOLS_READS_QC_FAILED:
        :type SAMTOOLS_READS_QC_FAILED: double
        :param SAMTOOLS_READS_UNMAPPED:
        :type SAMTOOLS_READS_UNMAPPED: double
        :param SAMTOOLS_SEQUENCES:
        :type SAMTOOLS_SEQUENCES: double
        :param SAMTOOLS_TOTAL_LENGTH:
        :type SAMTOOLS_TOTAL_LENGTH: double
        :param samtoolsScope:
        :type samtoolsScope: SamtoolsScope
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
